var CookieUtil =  new function(){
	this.hide=function(id){this.setShowHideCookie(id, 'hide')};
	this.clear=function(id){this.setShowHideCookie(id, '')};
    this.getCookieValue=function(id) {
	    var eq = id + "=";
	    var ca = document.cookie.split(';');
	    for(var i=0;i<ca.length;i++) {
	        var c = ca[i];
	        while (c.charAt(0)==' ') { c = c.substring(1,c.length); }
	        if (c.indexOf(eq) == 0) { return c.substring(eq.length,c.length); }
	    }
	    return null;
	};
	this.saveCookie=function(id,value,days) {
	  var ex;
	  var sessionId = this.getCookieValue("JSESSIONID");
	  if (days) {
	    var d = new Date();
	    d.setTime(d.getTime()+(days*24*60*60*1000));
	    ex = "; expires="+d.toGMTString();
	  }
	  else { ex = ""; }
	  document.cookie = id + "=" + value + ex ;
	  document.cookie = "JSESSIONID" + "=" + sessionId + "; path=/";
	};
	this.readCookie=function(id, defaultValue){
		var cookieVal = this.getCookieValue(id);
		if(cookieVal != null) return cookieVal;
		if (defaultValue)return defaultValue;
		return null;
	};
	this.setShowHideCookie=function(id, value){
	    if(value=="hide") this.saveCookie(id, value,365);
	    else this.saveCookie(id,"",-1);
	};
	this.toggleVisibility=function (id, idToShow, idToHide){
       	if(GH.Util.isVisible(id)) {
            GH.Util.hide(id);
       		GH.Util.switchView(idToShow,idToHide);
       		this.setShowHideCookie(id, "hide");
       	}else{
       		GH.Util.switchView(idToHide,idToShow);
            GH.Util.show(id);
            this.setShowHideCookie(id, "show");
       	}
    };
	this.initBoardsToggle=function(id, idToShow, idToHide){
		if(this.readCookie(id, "show")=="hide"){ GH.Util.hide(id); GH.Util.switchView(idToShow,idToHide);	}
		else{ GH.Util.show(id); GH.Util.switchView(idToHide,idToShow); }
	};
	this.initColumnToggle=function(){
		if(this.readCookie("column", "show")=="hide"){
			GH.Util.hide("gh-column");
			GH.Util.addClassName("gh", "gh-column-hidden");
		}
	};
	this.toggleColumn = function () {
		if(GH.Util.isVisible("gh-column")){
			GH.Util.addClassName("gh", "gh-column-hidden");

		}
		else if(!GH.Util.isVisible("gh-column")){
			GH.Util.removeClassName("gh", "gh-column-hidden");
		}
		this.toggleVisibility("gh-column","","");
    };
	this.expandAllBoards=function(classname, el){
		var list = $$(el+'[class^="'+classname+'"]');
		for(var i=0;i<list.length;i++){	this.expandBoard(list[i].id); }
	};
	this.colapseAllBoards=function(classname, el){
		var list = $$(el+'[class^="'+classname+'"]');
		for(var i=0;i<list.length;i++){	this.colapseBoard(list[i].id); }
	};
	this.expandBoard=function(id){
		this.setShowHideCookie(id, "show");
	  	GH.Util.switchView('colapse_'+this.getDbId(id),'expand_'+this.getDbId(id));
        GH.Util.show(id);
	};	
	this.colapseBoard=function(id){
		this.setShowHideCookie(id, "hide");
	  	GH.Util.switchView('expand_'+this.getDbId(id),'colapse_'+this.getDbId(id));
        GH.Util.hide(id);
	};		
	this.getDbId=function(elementId){
		var dbid =elementId.split("_");
       	return dbid[dbid.length -1];
	};	
};