GADGET = {};

/**
 * Ajax requests to be executed before calling template()
 */
GADGET.templateArgs = function(baseUrl) {
	return [
		{
		    key: "ghCardViewGadget",
		    ajaxOptions: function()
		    {
				var gadget = this;
				return {
				      url: baseUrl + "/rest/greenhopper/1.0/card-view/generate",
				      data: {
				          selectedProjectId: gadgets.util.unescapeString(gadget.getPref("selectedProjectId")),
				          selectedBoardId: gadget.getPref("selectedBoardId"),
				          contextName: gadget.getPref("contextName"),
				          assignedToMe: gadget.getPref("assignedToMe"),
				          width: Math.min(gadgets.window.getViewportDimensions().width, 800),
				          projectOrIssue: gadget.getPref("projectOrIssue"),
				          selectedIssueKey: gadget.getPref("selectedIssueKey"),
				          start: gadget.getPref("start")
				      }
				}
	        }
	    }
	];
}

//this is the view template, which is rendered after the dashboard delivers your ajax results
GADGET.template = function (gadget, args, baseUrl) {

    gadget.getView().empty();
	var body = AJS.$('body');
	body.addClass('greenhopper-card-view-gadget');
	if (GH.gadget.utils.getViewName() == 'wallboard') body.addClass('wallboard');
    
    
    if (args.ghCardViewGadget.start)
    {
        gadget.savePref("start", args.ghCardViewGadget.start.toString());
    }
    var removeFieldLinks = function()
    {
        var fieldLinks = AJS.$(".gh-issue-body a");
        var parentDiv;
        fieldLinks.each(function()
        {
            //append the text currently inside the anchor element to the parent element
            parentDiv = AJS.$(this).parent();
            parentDiv.append(this.text);
            AJS.$(this).remove();
        });

    };
    var renderCards = function()
    {
        var issueCards = "";
        var cardsSlideshow = AJS.$("<div/>");
        var cardsContainer = AJS.$("<div/>");
        var cardSlide = "";
        var card = "";

        if (args.ghCardViewGadget.issues && args.ghCardViewGadget.issues.length > 0)
        {
            cardsSlideshow.attr({id: "slideshow"});
            cardsContainer.attr({id: "slides-container"});

            AJS.$(args.ghCardViewGadget.issues).each(function()
            {
                cardSlide = AJS.$("<div/>").attr({id: this.issueKey}).addClass("slide ");
                cardSlide.html(this.cardHtml);
                cardsContainer.append(cardSlide);
            });


        }
        else
        {
            cardsContainer.text("There are no issues for this version");
        }
        cardsSlideshow.append(cardsContainer);
        return function()
        {
            return cardsSlideshow;
        };
    }();
    var renderCardsSlideshow = function()
    {
        var currentPosition = parseInt(gadget.getPref("currentPosition"));
        var slideWidth = 270;
        var slides = AJS.$('.slide');
        var numberOfSlides = slides.length;
        var slideControls = AJS.$("<div/>").attr({id: 'slides-control'});
        var prevControlWrapper = AJS.$('<span/>').attr({id: 'prev-control'}).addClass("control");
        var nextControl = AJS.$('<span/>').attr({id: 'next-control'}).addClass("control");

        AJS.$('#slides-container').css('overflow', 'hidden');

        slides.wrapAll('<div id="slide-inner"></div>')
                .css({
            'float' : 'left',
            'width' : slideWidth
        });

        AJS.$('#slide-inner').css('width', slideWidth * numberOfSlides);

        AJS.$(slideControls).append(prevControlWrapper).append(nextControl);
        AJS.$('#slideshow').append(slideControls);
        if (currentPosition != 0)
        {
            AJS.$('#slide-inner').animate({
                'marginLeft' : slideWidth * (-currentPosition)
            });
        }


        manageControls(currentPosition);

        AJS.$('.control')
                .bind('click', function()
        {
            currentPosition = (AJS.$(this).attr('id') == 'next-control')
                    ? currentPosition + 1 : currentPosition - 1;

            manageControls(currentPosition);
            AJS.$('#slide-inner').animate({
                'marginLeft' : slideWidth * (-currentPosition)
            });
        });

        function manageControls(position)
        {
            AJS.$('#next-control').show();
            AJS.$('#prev-control').show();
            if (position == -1)
            {
                //update
                //update the startPosition
                gadget.savePref("start", args.ghCardViewGadget.previousStart.toString());


                gadget.savePref("currentPosition", (args.ghCardViewGadget.itemsPerPage - 1).toString());

                gadget.showView(true);
            }
            else if (position == 0)
            {
                //if there is a previous pagination make ajax call to render cards
                //on previous page
                if (args.ghCardViewGadget.previousStart == null)
                {
                    AJS.$('#prev-control').hide();
                }
                if (numberOfSlides == 1)
                {
                    AJS.$('#next-control').hide();
                }
            }
            else if (position == numberOfSlides - 1)
            {
                if (args.ghCardViewGadget.nextStart == null)
                {
                    AJS.$('#next-control').hide()
                }
            }
            else if (position == numberOfSlides)
            {
                //update the startPosition
                gadget.savePref("start", args.ghCardViewGadget.nextStart.toString());
                gadget.savePref("currentPosition", "0");
                gadget.showView(true);
            }
            else
            {
            }
        }
    };
    var setIssueIconsAndIssueLink = function()
    {
        var issueLink = "";
        if (args.ghCardViewGadget.issues && args.ghCardViewGadget.issues.length > 0)
        {
            //empty all the issueKey divs
            AJS.$('.gh-issue-key').empty();
            AJS.$(args.ghCardViewGadget.issues).each(function()
            {
                //overide the css for the issueType icon
                AJS.$('#' + this.issueKey + ' .gh-issue-type').css("background-image", "url('" + gadget.getBaseUrl() + this.issueTypeUrl + "')");
                //empty the issue key div
                issueLink = AJS.$("<a/>").attr({href: gadget.getBaseUrl() + "/secure/VersionBoard.jspa?selectedBoardId="
                        + this.selectedBoardId + "&selectedProjectId=" + this.selectedProjectId + "&key=" + this.issueKey}).text(this.issueKey);
                AJS.$('#' + this.issueKey + ' .gh-issue-key').append(issueLink);
                if (this.priorityUrl != null)
                {
                    AJS.$('#' + this.issueKey + ' .gh-issue-priority').css("background-image", "url('" + gadget.getBaseUrl() + this.priorityUrl + "')");
                }

            });
        }
    };

    var getMainContainer = function()
    {
        var mainDiv = AJS.$("<div/>").attr({id:"main-container"}).addClass("main-container gh-cards");
        mainDiv.append(renderCards());
        gadget.getView().append(mainDiv);
        return function()
        {
            return mainDiv;
        }
    }();
    getMainContainer();
    renderCardsSlideshow();
    setIssueIconsAndIssueLink();
    removeFieldLinks();
    console.log("selectedBoardId=" + gadget.getPref("selectedBoardId"));
};


/**
 * Handles the switch between select project and select issue key controls in the configuration screen
 */
GADGET.selectByProjectOrByIssueKey = function(gadget,projectAndVersionSelectWrapper, issueFieldId, projectOrIssueUserPref, issueKeyUserPref)
{
    return {
        userpref: projectOrIssueUserPref,
        label: gadget.getMsg("gh.gadget.card.view.projectOrIssueKey.label"),
        description:gadget.getMsg("gh.gadget.card.view.projectOrIssueKey.description"),
        id: "proj_issue_picker_" + projectOrIssueUserPref,
        type: "callbackBuilder",
        callback: function(parentDiv)
        {
            parentDiv.append(
                    AJS.$("<fieldSet/>").append(
                            AJS.$("<input type='radio'/>").attr({value: "project", name: projectOrIssueUserPref}).addClass("radio proj-issue-option")
                            ).append(gadget.getMsg("gh.gadget.card.view.project")).append(
                            AJS.$("<input type='radio'/>").attr({value: "issue", name: projectOrIssueUserPref}).addClass("radio proj-issue-option")
                            ).append(gadget.getMsg("gh.gadget.card.view.issue"))
            );

            function enableSelectionByProject()
            {
                AJS.$("#"+issueFieldId).empty();                
                AJS.$("#" + issueFieldId).parent().attr({disabled: "true"}).addClass("hidden");
                AJS.$(projectAndVersionSelectWrapper).parent().removeClass("hidden");

               
                //update the projectOrIssueUserPref
                AJS.$("proj_issue_picker_" + projectOrIssueUserPref).val("project");

               // gadget.savePref(projectOrIssueUserPref, "project");

                gadget.resize();
            }

            function enableSelectionByIssueKey()
            {
                AJS.$(projectAndVersionSelectWrapper).parent().attr({disabled: "true"}).addClass("hidden");
                AJS.$("#" + issueFieldId).parent().removeAttr("disabled").removeClass("hidden");
                //update the projectOrIssueUserPref
                AJS.$("proj_issue_picker_" + projectOrIssueUserPref).val("issue");

                gadget.resize();
            }
            var radioButtons = AJS.$("#proj_issue_picker_" + projectOrIssueUserPref + " input[type='radio']");
            
            // select what was selected before
            var projectOrIssue = gadget.getPref(projectOrIssueUserPref);
            if (projectOrIssue == 'issue') {
            	radioButtons.val(["issue"]);
            	enableSelectionByIssueKey();
            } else {
            	radioButtons.val(["project"]);
            	enableSelectionByProject();
            }
            radioButtons.click(function(e)
            {
                var type = AJS.$(this).attr("checked", "checked").val();
                if (type == "project")
                {
                    enableSelectionByProject();
                }
                else
                {
                    enableSelectionByIssueKey();
                }
            });
        }
    }
};

GADGET.descriptorArgs = function (baseUrl) {
    return [
        {
            key: "projectOptions",
            ajaxOptions:  baseUrl + "/rest/greenhopper/1.0/project-list"
        }
    ];
};

//defines any preferences. 
GADGET.descriptor = function (gadget, args, baseUrl) {
    //makes sure start and current position are reset back to 0 every time
    //user goes to gadget config
    gadget.savePref("start", "0");
    gadget.savePref("currentPosition", "0");
    var issuePicker =
    {
        id: "issue_picker_selectedIssueKey",
        userpref: "selectedIssueKey",
        label: gadget.getMsg("Issue Key"),
        description: gadget.getMsg("Enter in the issue key for the issue you wish to see"),
        value: gadget.getPref("selectedIssueKey"),
        type: "callback",
        callback: function (parentDiv)
        {
            parentDiv.append("<div/>").attr({id: linkKey - picker});
            new AJS.IssuePicker("#linkKey-picker");
        }
    };

    return {
        action: baseUrl + "/rest/greenhopper/1.0/card-view/validate",
        theme : function()
        {
            if (gadgets.window.getViewportDimensions().width < 450)
            {
                return "gdt top-label";
            }
            else
            {
                return "gdt";
            }
        }(),
        fields: [
            GADGET.selectByProjectOrByIssueKey(gadget, "#project_picker_selectedProjectId, #version_picker_selectedBoardId", "issue_picker_selectedIssueKey", "projectOrIssue", "selectedIssueKey"),
            issuePicker,
            GH.gadget.fields.projectPicker(gadget, "selectedProjectId", args.projectOptions.options),
            GH.gadget.fields.versionPicker(gadget, "selectedProjectId", "selectedBoardId", true, true),
            AJS.gadget.fields.nowConfigured()
        ]
    };
};
